# Change log for the `llvm-tf` package

## 3.1.0.1

* `addFunctionMapping` checks for functions
  that are eliminated by optimization passes.
  This fixes a crash when working with optimizations and call-back functions.

## 3.1

* `ExecutionEngine` is now managed by a `ForeignPtr` with a finalizer.
  That is, you must keep the `ExecutionEngine` alive
  as long as you call compiled functions.

  `FreePointers` and `getFreePointers` are gone.

## 3.0.3

* `constVector`, `constArray`, `vector` do no longer cycle the vector
  Instead they check for the appropriate static length.

* `FFI.constVector`, `FFI.constArray` must be in IO
  in order to proper sequence actions in `Core.Util.constVector`, `Core.Util.constArray`.
  Currently, in `Util.constVector` it is possible that `FFI.constArray`
  is called too late and thus operates on a released pointer.
